lost exception

I have a simple question.
 
If an exception is generated and a new exception is generated due to re-throwing the information about the first exception is lost. What will happen to the error in the try block if the original exception is lost. I am trying to make sense of it and it is a very vague part of exceptions so if anyone can aid me in this matter I would be very happy.

Thanks,
Zac
LVL 1
saculAsked:
Who is Participating?
I wear a lot of hats...

"The solutions and answers provided on Experts Exchange have been extremely helpful to me over the last few years. I wear a lot of hats - Developer, Database Administrator, Help Desk, etc., so I know a lot of things but not a lot about one thing. Experts Exchange gives me answers from people who do know a lot about one thing, in a easy to use platform." -Todd S.

JakobACommented:
When an exception is thrown normal processing stops, and the program exits loops, methods and whatever until arriving at a point where the thrown exception is caught. Thus it is not possible to throw another exeption until the first one has been caught.

regards JakobA
0
objectsCommented:
> and a new exception is generated due to re-throwing the
> information about the first exception is lost.

If you r simply rethrowing the exception, then no new exception is created and the first exception is not lost.
0
saculAuthor Commented:
ok..well what if the exception is caught and re-thrown from the catch block. This result in a new exception(I think). For instance if you call the fillInStackTrace() and assign this to a variable that references an Exception. Then that Exception can be re-thrown. But if an exception is re-thrown from the catch block that is not related to the error, is this possible? and is the information encapsulated in the original object lost? will the program stop?

I was reading up on this and this is what the text said,

"Information about the exception can also be lost if while re-throwing, a new exception is created. The original exception is lost."



Thanks
Zac
0
Cloud Class® Course: Amazon Web Services - Basic

Are you thinking about creating an Amazon Web Services account for your business? Not sure where to start? In this course you’ll get an overview of the history of AWS and take a tour of their user interface.

objectsCommented:
Depends what you mean by re-throwing.

catch (Exception ex)
{
   throw ex;   // same exception is thrown
}


catch (Exception ex)
{
   throw new Exception("blah blah");  // new exception, original lost
}

0
objectsCommented:
But there's nothing stopping you saving a reference to the exception or incluing it with the nex exception though:

catch (Exception ex)
{
   throw new MyException(ex);
}


catch (Exception ex)
{
   storedex = ex;
   throw new Exception("blah blah");
}

0

Experts Exchange Solution brought to you by

Your issues matter to us.

Facing a tech roadblock? Get the help and guidance you need from experienced professionals who care. Ask your question anytime, anywhere, with no hassle.

Start your 7-day free trial
JakobACommented:
I dont get it.  The exception variable is defined as part of the catch block, and it is no different than any other block:
    {
        int i = 25;          // 'i' is local to this block just like 'ex' is local to object's catch-block abowe
        throw new Exception( "bye" );
        ...
    }
when the exception is thrown that block gets left behind and the variable i is lost.


0
objectsCommented:
not exactly, yes the variable goes out of scope. But the instance that it references is not lost.

eg.

public Object someFunction()
{
   String s = "abc";
   return s;
}
0
JakobACommented:
True, you can send the data out of the block before it terminate. but isnt that still bogstandard Java scope rules.
0
objectsCommented:
> but isnt that still bogstandard Java scope rules.

Yes, exceptions are simply object instances like anything else.
0
saculAuthor Commented:
> catch (Exception ex)
  {
      throw new Exception("blah blah");  // new exception, original lost
  }

So you would never throw a new Exception in the catch block then with the risk of loosing the original one? and if you do would the execution in main stop?

thanks,

Zac
0
JakobACommented:
not unless you saved the first before throwing the second (or leaving the catch block in some other way).

class TestExcep {

    static Exception[] exes = new Exception[500];
    static int EIndex = 0;

    static void someMethod( int nr ) throws Exception {
         try {
              if ( nr > 0 ) {
                   someMethod( nr-1 );
              }
              throw new Exception( "try block: exception nr " +nr );
         } catch ( Exception e ) {
              exes[ EIndex++ ] = e;
              throw new Exception( "catch block: exception nr " +nr );
        }
   }

   public static void main ( String[] args ) {
       try {
            someMethod( 5 );
       } catch ( Exception e2 ) {
            System.out.println( e2.getMessage( ) );   // the exception caught
            while ( EIndex > 0 ) {
                System.out.println( exes[--EIndex].getMessage() );   // exceptions thrown earlier
            }
       }
  }  // end of main

} //endclass TestExcep
 
regards JakobA
0
JakobACommented:
No, main would not stop. All that would happen when 'losing' the exception is that you would not have acces to the information it contained any more.
0
objectsCommented:
> then with the risk of loosing the original one?

There's not really any risk, you'd only do that if you did not need the original exception anymore.
0
saculAuthor Commented:
ok I got the theoretical part of it now I just have to understand why you want to throw a new exception in a catch block, but that is for another time. I haven't been programming java for long and this is a somewhat diffuse topic. Thanks to you, experts, I know have a better understanding of it.

thank you,
Zac
0
objectsCommented:
0
JakobACommented:
I guess the point is that exceptions throw themselves when you try to do someting you cannot. So inside your catch-block you should be extra carefull, knowing that your program logic assumptions are already a bit dubious seeing as how the first exception got thrown.

regards JakobA
0
It's more than this solution.Get answers and train to solve all your tech problems - anytime, anywhere.Try it for free Edge Out The Competitionfor your dream job with proven skills and certifications.Get started today Stand Outas the employee with proven skills.Start learning today for free Move Your Career Forwardwith certification training in the latest technologies.Start your trial today
Java

From novice to tech pro — start learning today.

Question has a verified solution.

Are you are experiencing a similar issue? Get a personalized answer when you ask a related question.

Have a better answer? Share it in a comment.